--
--  CustomDocument.applescript
--  current
--
--  Created by Bill on 2/10/17.
--  Copyright © 2017 BillKopp547. All rights reserved.
--

script CustomDocument
	property parent : class "NSDocument"
	
	property myTextView : missing value
    property attributedStringToLoadIntoTextView : missing value
	
    
	on init()
        
		continue init()
		
		-- Add your subclass-specific initialization here.
		-- If an error occurs here, return missing value.
		
		return me
	end init
	
    
	on windowNibName()
		-- Override returning the nib file name of the document
		-- If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
		return "CustomDocument"
	end windowNibName
	
    
	on dataOfType:typeName |error|:outError
		
        set theData to missing value
        
		-- Insert code here to write your document to data of the specified type. If the given outError is not missing value, ensure that you set contents of outError when returning missing value.
        -- You can also choose to override -fileWrapperOfType:error:, -writeToURL:ofType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.
        
        -- RICHARD SAYS: we really should look at typeName to see what type we need to generate rather than just assuming it is RTF
        set entireLength to myTextView's |string|'s |length|
        set range to (current application's NSMakeRange(0, entireLength))
        set theData to myTextView's RTFFromRange:range
 
        -- Return true if successful or false if there was an error
        set succeeded to (theData is not missing value)
        
		if not succeeded and outError is not missing value then
			set contents of outError to current application's NSError's errorWithDomain:(current application's NSCocoaErrorDomain) code:(current application's NSFileWriteUnknownError) userInfo:(missing value)
		end if
		
		-- Return your document's contents as data, or missing value if there was an error.
		return theData
	end dataOfType:|error|:
	

	on readFromData:theData ofType:typeName |error|:outError
		
		-- Insert code here to read your document from the given data of the specified type. If the given outError is not missing value, ensure that you set contents of outError when returning false.
		-- You can also choose to override -readFromFileWrapper:ofType:error: or -readFromURL:ofType:error: instead.
		
        -- RICHARD SAYS: we really should look at typeName to see what type we need to injest rather than just assuming it is RTF
        -- we have to stash the loaded text in a temporary storage location because the text view does not exist until after the NIB is loaded
        set attributedStringToLoadIntoTextView to current application's NSAttributedString's alloc's initWithRTF:theData documentAttributes:(missing value)
        
         -- Return true if successful or false if there was an error.
        set succeeded to (attributedStringToLoadIntoTextView is not missing value)
        
		if not succeeded and outError is not missing value then
			set contents of outError to current application's NSError's errorWithDomain:(current application's NSCocoaErrorDomain) code:(current application's NSFileReadUnknownError) userInfo:(missing value)
		end if
        
		return succeeded
	end readFromData:ofType:|error|:
    
    
    on windowControllerDidLoadNib:aController
        
        continue windowControllerDidLoadNib:aController
        
        -- the nib has loaded, so set text view content from the loaded text we stashed in previouslySavedText
        if attributedStringToLoadIntoTextView is not missing value then
            
            set theTextStorage to myTextView's textStorage
            theTextStorage's setAttributedString:attributedStringToLoadIntoTextView

            set attributedStringToLoadIntoTextView to missing value
        end if
    end windowControllerDidLoadNib:
    

	on autosavesInPlace()
		-- Return true if you wish to support autosaving and versions, false if you do not.
		return true
	end autosavesInPlace
	
end script
